## llvm-toolchain-13 13.0.0~+rc1

=== clang/tools/clang-repl/CMakeLists.txt ===
set( LLVM_LINK_COMPONENTS
  ${LLVM_TARGETS_TO_BUILD}
  Core
  Option
  OrcJIT
  Support
  )

add_clang_executable(clang-repl
  ClangRepl.cpp
  )

clang_target_link_libraries(clang-repl PUBLIC
  clangBasic
  clangInterpreter
  clangTooling
  LLVMLineEditor
  )

=== clang/tools/libclang/CMakeLists.txt ===
set(SOURCES
  ARCMigrate.cpp
  BuildSystem.cpp
  CIndex.cpp
  CIndexCXX.cpp
  CIndexCodeCompletion.cpp
  CIndexDiagnostic.cpp
  CIndexHigh.cpp
  CIndexInclusionStack.cpp
  CIndexUSRs.cpp
  CIndexer.cpp
  CXComment.cpp
  CXCursor.cpp
  CXIndexDataConsumer.cpp
  CXCompilationDatabase.cpp
  CXLoadedDiagnostic.cpp
  CXSourceLocation.cpp
  CXStoredDiagnostic.cpp
  CXString.cpp
  CXType.cpp
  Indexing.cpp
  FatalErrorHandler.cpp
  Rewrite.cpp

  ADDITIONAL_HEADERS
  CIndexDiagnostic.h
  CIndexer.h
  CXCursor.h
  CXLoadedDiagnostic.h
  CXSourceLocation.h
  CXString.h
  CXTranslationUnit.h
  CXType.h
  Index_Internal.h
  ../../include/clang-c/Index.h
  )

set(LIBS
  clangAST
  clangBasic
  clangDriver
  clangFrontend
  clangIndex
  clangLex
  clangRewrite
  clangSema
  clangSerialization
  clangTooling
)

if (CLANG_ENABLE_ARCMT)
  list(APPEND LIBS clangARCMigrate)
endif ()

if (HAVE_LIBDL)
  list(APPEND LIBS ${CMAKE_DL_LIBS})
elseif (CLANG_BUILT_STANDALONE)
  find_library(DL_LIBRARY_PATH dl)
  if (DL_LIBRARY_PATH)
    list(APPEND LIBS dl)
  endif ()
endif ()

option(LIBCLANG_BUILD_STATIC
  "Build libclang as a static library (in addition to a shared one)" OFF)

set(LLVM_EXPORTED_SYMBOL_FILE ${CMAKE_CURRENT_BINARY_DIR}/libclang-generic.exports)
set(LIBCLANG_VERSION_SCRIPT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/libclang.map)

if(MSVC)
  # Avoid LNK4197 by not specifying libclang.exports here.
  # Each functions is exported as "dllexport" in include/clang-c.
  # KB835326
  set(LLVM_EXPORTED_SYMBOL_FILE)
endif()

if (UNIX AND NOT APPLE)
  set(LLVM_EXPORTED_SYMBOL_FILE)
  set(USE_VERSION_SCRIPT ${LLVM_HAVE_LINK_VERSION_SCRIPT})
endif()

if (LLVM_EXPORTED_SYMBOL_FILE)
  add_custom_command(OUTPUT ${LLVM_EXPORTED_SYMBOL_FILE}
                     COMMAND "${Python3_EXECUTABLE}"
                       ARGS ${CMAKE_CURRENT_SOURCE_DIR}/linker-script-to-export-list.py
                            ${LIBCLANG_VERSION_SCRIPT_FILE}
                            ${LLVM_EXPORTED_SYMBOL_FILE}
                     DEPENDS ${LIBCLANG_VERSION_SCRIPT_FILE})
endif()

if(LLVM_ENABLE_PIC OR (WIN32 AND NOT LIBCLANG_BUILD_STATIC))
  set(ENABLE_SHARED SHARED)
endif()

if(NOT LLVM_ENABLE_PIC OR LIBCLANG_BUILD_STATIC)
  set(ENABLE_STATIC STATIC)
endif()

if (MSVC AND ENABLE_SHARED AND ENABLE_STATIC)
  unset(ENABLE_STATIC)
endif()

if(MSVC)
  set(output_name "libclang")
else()
  set(output_name "clang")
endif()

# libclang requires headers which need _ALL_SOURCE to build on AIX
if (UNIX AND ${CMAKE_SYSTEM_NAME} MATCHES "AIX")
    remove_definitions("-D_XOPEN_SOURCE=700")
endif()

add_clang_library(libclang ${ENABLE_SHARED} ${ENABLE_STATIC} INSTALL_WITH_TOOLCHAIN
  OUTPUT_NAME ${output_name}
  ${SOURCES}

  DEPENDS
  ClangDriverOptions
  clang-resource-headers

  LINK_LIBS
  ${LIBS}

  LINK_COMPONENTS
  ${LLVM_TARGETS_TO_BUILD}
  Core
  Support
  )

if(ENABLE_STATIC)
  foreach(name libclang obj.libclang libclang_static)
    if (TARGET ${name})
      target_compile_definitions(${name} PUBLIC CINDEX_NO_EXPORTS)
    endif()
  endforeach()
endif()

if(ENABLE_SHARED)
  if(WIN32)
    set_target_properties(libclang
      PROPERTIES
      VERSION ${LIBCLANG_LIBRARY_VERSION}
      DEFINE_SYMBOL _CINDEX_LIB_)
  elseif(APPLE)
    set(LIBCLANG_LINK_FLAGS " -Wl,-compatibility_version -Wl,1")
    set(LIBCLANG_LINK_FLAGS "${LIBCLANG_LINK_FLAGS} -Wl,-current_version -Wl,${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH}")

    set_property(TARGET libclang APPEND_STRING PROPERTY
                 LINK_FLAGS ${LIBCLANG_LINK_FLAGS})
  else()
    set_target_properties(libclang
      PROPERTIES
      VERSION ${LIBCLANG_LIBRARY_VERSION}
      DEFINE_SYMBOL _CINDEX_LIB_)
    # FIXME: _CINDEX_LIB_ affects dllexport/dllimport on Win32.
    if(LLVM_ENABLE_MODULES AND NOT WIN32)
      target_compile_options(libclang PRIVATE
        "-fmodules-ignore-macro=_CINDEX_LIB_"
        )
    endif()
  endif()
  if (USE_VERSION_SCRIPT)
    target_link_options(libclang PRIVATE "-Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/libclang.map")
    # Ensure that libclang.so gets rebuilt when the linker script changes.
    set_property(SOURCE ARCMigrate.cpp APPEND PROPERTY
                 OBJECT_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/libclang.map)

    # The SOVERSION should be updated only if a change is made to the libclang
    # ABI, and when it is updated, it should be updated to the current
    # LLVM_VERSION_MAJOR.
    set_target_properties(libclang PROPERTIES
                          VERSION ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH}${LLVM_VERSION_SUFFIX}
                          SOVERSION 13)
  endif()
endif()

if(INTERNAL_INSTALL_PREFIX)
  set(LIBCLANG_HEADERS_INSTALL_DESTINATION "${INTERNAL_INSTALL_PREFIX}/include")
else()
  set(LIBCLANG_HEADERS_INSTALL_DESTINATION include)
endif()

install(DIRECTORY ../../include/clang-c
  COMPONENT libclang-headers
  DESTINATION "${LIBCLANG_HEADERS_INSTALL_DESTINATION}"
  FILES_MATCHING
  PATTERN "*.h"
  )

# LLVM_DISTRIBUTION_COMPONENTS requires that each component have both a
# component and an install-component target, so add a dummy libclang-headers
# target to allow using it in LLVM_DISTRIBUTION_COMPONENTS.
add_custom_target(libclang-headers)
set_target_properties(libclang-headers PROPERTIES FOLDER "Misc")

if (NOT LLVM_ENABLE_IDE)
  add_llvm_install_targets(install-libclang-headers
                           COMPONENT libclang-headers)
endif()

# Create a target to install the python bindings to make them easier to
# distribute.  Since the bindings are over libclang, which is installed
# unbundled to the clang version, follow suit.
foreach(PythonVersion ${CLANG_PYTHON_BINDINGS_VERSIONS})
  install(DIRECTORY
            ${CMAKE_CURRENT_SOURCE_DIR}/../../bindings/python/clang
          COMPONENT
            libclang-python-bindings
          DESTINATION
            "lib${LLVM_LIBDIR_SUFFIX}/python${PythonVersion}/site-packages")
endforeach()
if(NOT LLVM_ENABLE_IDE)
  add_custom_target(libclang-python-bindings)
  add_llvm_install_targets(install-libclang-python-bindings
                           COMPONENT
                             libclang-python-bindings)
endif()

=== debian/changelog ===
llvm-toolchain-13 (1:13.0.0~+rc1-2) unstable; urgency=medium

  * clang-soname-extract-version.diff: improve the upstream declaration
  * Fix the libclang links

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 19 Aug 2021 18:13:56 +0200

llvm-toolchain-13 (1:13.0.0~+rc1-1) unstable; urgency=medium

  * Upload to Unstable
  * Add symbol clang_CompileCommand_getNumMappedSources to libclang
  * Add a new variable called SONAME_CLANG as
    clang soname has started with llvm-toolchain-13.
    it is normal that 13 is what is seen in 14 or later version as
    it is bumped only with abi changes

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 16 Aug 2021 16:00:12 +0200

llvm-toolchain-13 (1:13.0.0~+rc1-1~exp1) unstable; urgency=medium

  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 03 Aug 2021 09:36:26 +0200

llvm-toolchain-13 (1:13~++20210731010128+6eaf46beb462-1~exp1) experimental; urgency=medium

  * Branching of snapshot into 13
  * Adjust libclang:
    - upstream decided to make it stable starting from 13, with the soname
    - for now, I am not planning to rename libclang1-13 to libclang13 as it will
      cause too much churn for a small gain as we will keep libllvm (while
      losing the capability to have different versions in parallel installed)
      See upstream c7b3a91017d26266d7556b1ac7c49b06f0109b91

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Jul 2021 09:40:58 +0200

llvm-toolchain-snapshot (1:13~++20210715093511+afc760ef3527-1~exp1) experimental; urgency=medium

  * Refresh the lib of symbols in libomp
  * As scan-build-py is installed by default ( https://reviews.llvm.org/D104138 )
    update of the code
  * Revert "Revert D94333.diff as it breaks the ci
    https://reviews.llvm.org/D94333#2829043"
  * Install usr/lib/llvm-13/lib/cmake/openmp/FindOpenMPTarget.cmake
    in libomp-13-dev.install
  * Revert of D103865 for causing bug 51026

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 15 Jul 2021 21:46:58 +0200

llvm-toolchain-snapshot (1:13~++20210619101720+e1adf90826a5-1~exp1) experimental; urgency=medium

  * Enable lld on s390x
  * remove libomptarget from openmp. done by upstream
    in f2f88f3e7a110b2d4d9da446e45f0dba040e62b2
    but install /usr/lib/llvm-13/lib/libomptarget-amdgcn-*.bc
    Only install these files on amd64, ppc64el & arm64
    See openmp/libomptarget/deviceRTLs/amdgcn/CMakeLists.txt
  * Revert D94333.diff as it breaks the ci
    https://reviews.llvm.org/D94333#2829043

  [ John Paul Adrian Glaubitz ]
  * Disable OpenMP on m68k

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 08 May 2021 13:12:43 +0200

llvm-toolchain-snapshot (1:13~++20210418105309+a0898f0cecc7-1~exp1) experimental; urgency=medium

  [ Sylvestre Ledru ]
  * New snapshot release
  * "run-clang-tidy" install it
  * Only enable libomp-13-doc on supported archs
  * Verify that /proc is mounted. It makes some unexpected issues when
    building from a chroot without /proc
  * Fix the __config_site include issue
  * Revert D95727 for causing bug 49818

  [ John Paul Adrian Glaubitz ]
  * Add upstream patch D98574 to fix clang macro definitions on sparc64
  * Add upstream patch D98575 to fix 32-bit compiler-rt build on sparc64
  * Enable building the new experimental M68k backend
  * Set LLVM_HOST_TRIPLE to x86_64-linux-gnux32 on x32
  * Set LLVM_DEFAULT_TARGET_TRIPLE to x86_64-linux-gnux32 on x32

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 18 Apr 2021 11:00:31 +0200

llvm-toolchain-snapshot (1:13~++20210129063721+010b176cdefb-1~exp2) experimental; urgency=medium

  * Enable OpenMP offload capabilities for NVDIA GPUs
    See https://bugzilla.redhat.com/show_bug.cgi?id=1922914

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 01 Feb 2021 09:04:16 +0100

llvm-toolchain-snapshot (1:13~++20210129063721+010b176cdefb-1~exp1) experimental; urgency=medium

  [ Sylvestre Ledru ]
  * New branch (12 => 13)
  * Workaround a static_assert on https://bugs.llvm.org/show_bug.cgi?id=48259
    "static assertion failed: Recycler allocation size is less than object size!"
  * Also install usr/lib/llvm-12/bin/ld64.lld.darwinnew & usr/bin/ld64.lld.darwinnew-12
  * Also install usr/lib/llvm-12/lib/libomptarget.so.12 in libomp5-12

  [ Gianfranco Costamagna ]
  * Add upstream patch D92052 to fix a gcn offload compiler issue with gcc (Closes: #975692)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 30 Jan 2021 17:31:15 +0100

llvm-toolchain-12 (1:12.0.1-5) unstable; urgency=medium

  [ Jordan Justen ]
  * libclc: Include libclc spir-v outputs (used by Mesa opencl)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 Aug 2021 10:19:22 +0200

llvm-toolchain-12 (1:12.0.1-4) unstable; urgency=medium

  * Make libunwind-dev depends on libunwind
  * Don't build libunwind on hurd, armel, powerpc & mipsel
  * Remove old svn reference in the usage dh_strip & dh_makeshlibs

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 16 Aug 2021 22:04:17 +0200

llvm-toolchain-12 (1:12.0.1-3) unstable; urgency=medium

  * Build libunwind only on amd64 arm64 armhf i386
    mips64el ppc64el ppc64 riscv64 sparc sparc64
    Not supported on s390x for example
  * libc++ & libc++ abi: only pass -DLIBCXXABI_USE_LLVM_UNWINDER=YES
    if libunwind is available on the platform

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 01 Aug 2021 11:42:20 +0200

llvm-toolchain-12 (1:12.0.1-2) unstable; urgency=medium

  * Generate libunwind-12 & libunwind-12-dev packages
  * Add the following option to the libc++ build:
    -DLIBCXX_ENABLE_STATIC_ABI_LIBRARY=ON
    -DLIBCXX_STATICALLY_LINK_ABI_IN_STATIC_LIBRARY=ON
    -DLIBCXX_STATICALLY_LINK_ABI_IN_SHARED_LIBRARY=OFF
     to address upstream bug 46321
  * Make libc++abi use libunwind

  [ Kasper Kantz ]
  * Add riscv64 architecture in control
    enable liblldb, libomp and others which are
    currently unavailable in riscv64 repository.

  [ Krzysztof Aleksander Pyrkosz ]
  * Add libxml2 as a dependency as it is necessary


=== debian/control ===
Source: llvm-toolchain-13
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 9.0), cmake, chrpath, texinfo, sharutils,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses5-dev, swig, python3-six, python3-sphinx (>= 1.3.6),
    binutils-dev,
    libxml2-dev,
    libjsoncpp-dev, pkg-config,
    lcov, procps, help2man, zlib1g-dev,
    g++-multilib [amd64 i386 kfreebsd-amd64 mips mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
    libjs-mathjax, python3-recommonmark,
    doxygen, gfortran,
    ocaml-nox [amd64 arm64 armhf ppc64el s390x],
    ocaml-findlib [amd64 arm64 armhf ppc64el s390x],
    libctypes-ocaml-dev [amd64 arm64 armhf ppc64el s390x],
    dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el s390x],
    libpfm4-dev [linux-any], python3-setuptools, libz3-dev
Build-Conflicts: oprofile, ocaml
Standards-Version: 4.2.1
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b snapshot
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/snapshot

# ------------- clang -------------

Package: clang-13
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang-common-13-dev (= ${binary:Version}),
 libclang1-13 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler
Recommends: llvm-13-dev, python3, libomp-13-dev
Suggests: clang-13-doc
Breaks: llvm-13-dev (<< 1:13~++20210129063721)
Replaces: llvm-13-dev (<< 1:13~++20210129063721)
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-13
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-13 (= ${binary:Version}),
 python3
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, clang-cl, etc.

Package: clang-format-13
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm13 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-13
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm13 (= ${binary:Version}), libclang-common-13-dev,
 clang-tools-13, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-13
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libclang-common-13-dev (= ${binary:Version})
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-13-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-13
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-13-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-13 (= ${binary:Version}),
 libclang-common-13-dev (= ${binary:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-13.

Package: libclang-common-13-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm13 (= ${binary:Version})
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers and some libraries
 (profiling, etc).

Package: libclang-cpp13
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm13 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-cpp13-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang-cpp13 (= ${binary:Version})
# Move of libclang-cpp.so into libclang-cpp13.dev
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.
 .
 This package contains symlinks without a version number, which needed by
 linker at build time.


Package: libfuzzer-13-dev
Architecture: linux-any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-13 (= ${binary:Version})
Description: Library for coverage-guided fuzz testing
 LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
 of other libraries.
 .
 LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
 all of its fuzzing inside a single process. This in-process fuzzing can be
 more restrictive and fragile, but is potentially much faster as there is no
 overhead for process start-up.
 .
 The fuzzer is linked with the library under test, and feeds fuzzed inputs to
 the library via a specific fuzzing entrypoint (aka 'target function'); the
 fuzzer then tracks which areas of the code are reached, and generates mutations
 on the corpus of input data in order to maximize the code coverage. The code
 coverage information for libFuzzer is provided by LLVM's SanitizerCoverage
 instrumentation.


Package: python3-clang-13
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libclang-13-dev
Replaces: python-clang-x.y,
Conflicts: python-clang-x.y
Provides: python-clang-x.y
Description: Clang Python Bindings
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This binding package provides access to the Clang compiler and libraries.

Package: clang-13-examples
Architecture: any
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Clang examples
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang examples.

# ------------- LLVM -------------

Package: libllvm13
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Modular compiler and toolchain technologies, runtime library
 LLVM is a collection of libraries and tools that make it easy to build
 compilers, optimizers, just-in-time code generators, and many other
 compiler-related programs.
 .
 This package contains the LLVM runtime library.

Package: llvm-13-linker-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: llvm-13-dev (<< 1:13~++20210129063721), clang-13 (<< 1:13~++20210129063721)
Replaces: llvm-13-dev (<< 1:13~++20210129063721), clang-13 (<< 1:13~++20210129063721)
Description: Modular compiler and toolchain technologies - Plugins
 LLVM is a collection of libraries and tools that make it easy to build
 compilers, optimizers, just-in-time code generators, and many other
 compiler-related programs.
 .
 This package contains the LLVMgold and LLVMPolly linker plugins.

Package: llvm-13
Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# polly, openmp & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;libcxx;libcxxabi;compiler-rt;lld;debuginfo-tests

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
DEB_INST		:= $(CURDIR)/debian/tmp/

# Disable to move the previous method
BUILD_METHOD := stage2

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

LLVM_VERSION   := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_SNAPSHOT := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
endif

SONAME_EXT      := 1
# clang soname has started with llvm-toolchain-13.
# it is normal that 13 is what is seen in 14 or later version as
# it is bumped only with abi changes
SONAME_CLANG      := 13
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

include /usr/share/dpkg/architecture.mk

LDFLAGS_EXTRA =
CXXFLAGS_EXTRA =
CFLAGS_EXTRA =
CONFIGURE_EXTRA =
CMAKE_EXTRA = -DPYTHON_EXECUTABLE=/usr/bin/python3
CMAKE_LIBCXX_EXTRA =

BASE_PATH	:= $(CURDIR)
LIBCXX_EXCEPTIONS :=ON

ifneq (,$(filter $(DEB_HOST_ARCH),s390x))
	LIBCXX_EXCEPTIONS :=OFF
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386 armel mips mipsel powerpc powerpcspe riscv64))
CMAKE_EXTRA += -DLIBOMP_LIBFLAGS="-latomic" -DCMAKE_SHARED_LINKER_FLAGS="-latomic"
endif

ifneq (,$(filter $(DEB_HOST_ARCH),sparc sparc64))
CMAKE_EXTRA += -DLLVM_PARALLEL_LINK_JOBS=4
endif

ifneq (,$(filter $(DEB_HOST_ARCH),armel mipsel powerpc riscv64))
# For some reason, in the stage2 build, when clang is used to compile
# itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion everywhere.
LDFLAGS_EXTRA += -latomic
endif

# Ensure fixfilepath feature is disabled.  The fixfilepath feature
# sets a -ffile-prefix-map flag, which is only supported in clang-10.
# Disable also lto
export DEB_BUILD_MAINT_OPTIONS=reproducible=-fixfilepath optimize=-lto

# Cxx flags for building libcxx and libcxxabi
LIBCXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)

ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) lt 4.9-20140411-1~ ; echo $$?),0)
# Too old version of gcc. Force 4.9
	GCC_VERSION := 4.9
endif

Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libz3-dev) gt 4.7.0; echo $$?),0)
# no ocaml support in main for Ubuntu
ifneq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=ON
endif
endif

# Change the default CPU for s390x
ZARCH=z196
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
ZARCH=z13
endif
CMAKE_EXTRA += -DCLANG_SYSTEMZ_DEFAULT_ARCH=$(ZARCH)

export CC=gcc-$(GCC_VERSION)
export CXX=g++-$(GCC_VERSION)

opt_flags = -O2 -DNDEBUG -g1

ifneq (,$(findstring $(DEB_HOST_ARCH),armel))
  opt_flags += -marm
  # 3.8 fails to build, disable the compiler_rt builtins
  # See http://lists.llvm.org/pipermail/llvm-dev/2016-May/099761.html
  CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
  # Check for ancient libstdc++ fails due to atomics usage
  CMAKE_EXTRA_LIBCXX += -DLLVM_COMPILER_CHECKED=ON
  # Prevent clang from getting a > v4t default
  # See bug #868779
  CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabi
endif


ifneq (,$(findstring $(DEB_HOST_ARCH),armhf))
# avoid an issue with openmp on armhf
  CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=armv7l-unknown-linux-gnueabihf
endif

ifneq (,$(filter $(DEB_HOST_ARCH),mips64el))
# avoid an issue with search path on mips64el
# https://bugs.llvm.org/show_bug.cgi?id=41204
  CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=mips64el-linux-gnuabi64
endif

ifneq (,$(filter $(DEB_HOST_ARCH),x32))
  CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=x86_64-linux-gnux32
  CMAKE_EXTRA += -DLLVM_DEFAULT_TARGET_TRIPLE=x86_64-linux-gnux32
endif

ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) ge 4.8-20121128-1~ ; echo $$?),0)
	control_vars = '-Vdep:devlibs=libstdc++-$(GCC_VERSION)-dev, libgcc-$(GCC_VERSION)-dev' \
		'-Vdep:devlibs-objc=libobjc-$(GCC_VERSION)-dev'
else ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) ge 4.7.2-10~ ; echo $$?),0)
	control_vars = '-Vdep:devlibs=libstdc++6-$(GCC_VERSION)-dev, libgcc-$(GCC_VERSION)-dev' \
		'-Vdep:devlibs-objc=libobjc-$(GCC_VERSION)-dev'
else
	control_vars = '-Vdep:devlibs=libstdc++6-$(GCC_VERSION)-dev'
endif

# Disabled:
#  Host compiler does not support '-fuse-ld=lld'
# USE_LLD_ARCHS := amd64
# ifneq (,$(filter $(DEB_HOST_ARCH),$(USE_LLD_ARCHS)))
# 	CMAKE_EXTRA += -DLLVM_ENABLE_LLD=ON
# endif

BINUTILS_GOLD_ARCHS := amd64 arm64 armhf i386 ppc64 ppc64el x32 s390x hurd-i386 kfreebsd-amd64 kfreebsd-i386
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' binutils) ge 2.23.1-1~exp3 ; echo $$?),0)
ifneq (,$(filter $(DEB_HOST_ARCH),$(BINUTILS_GOLD_ARCHS)))
# -fused-ld=gold enables the gold linker (but is not supported by all archs / distro)
	LDFLAGS_EXTRA += -fuse-ld=gold
#--no-keep-files-mapped --no-map-whole-files
	CXXFLAGS_EXTRA += -fuse-ld=gold
	CFLAGS_EXTRA += -fuse-ld=gold
#-Wl,--no-keep-files-mapped -Wl,--no-map-whole-files
	CMAKE_EXTRA += -DLLVM_BINUTILS_INCDIR=/usr/include/
endif
endif

CODECOVERAGE=no
ifneq (,$(filter codecoverage,$(DEB_BUILD_OPTIONS)))
# enable the code coverage
	CODECOVERAGE=yes
# for -fvisibility-inlines-hidden see http://lists.cs.uiuc.edu/pipermail/llvm-commits/Week-of-Mon-20130729/183016.html
	CXXFLAGS_EXTRA += -fprofile-arcs -ftest-coverage
	LDFLAGS_EXTRA += -coverage -lgcov
	RUN_TEST=yes
    # OpenMP doesn't respect LDFLAGS
    CMAKE_EXTRA+= -DLIBOMP_LDFLAGS="-coverage -lgcov" # don't pass LDFLAGS_EXTRA because it expects gcc arg
endif

# Enable for bootstrap
LDFLAGS_EXTRA            += -fPIC -Wno-unused-command-line-argument -Wno-unknown-warning-option -Wl,--build-id
CXXFLAGS_EXTRA           += -fPIC -Wno-unused-command-line-argument -Wno-unknown-warning-option
BOOTSTRAP_CXXFLAGS_EXTRA  = $(CXXFLAGS_EXTRA) # Nothing for now. Keeping in case we need it
CFLAGS_EXTRA             += -fPIC -Wno-unused-command-line-argument -Wno-unknown-warning-option
BOOTSTRAP_CFLAGS_EXTRA    = $(CFLAGS_EXTRA) # Nothing for now. Keeping in case we need it

# Enable polly (or not)
POLLY_ENABLE=yes
ifneq (,$(filter $(DEB_HOST_ARCH), powerpc powerpcspe))
  POLLY_ENABLE=no
else
  PROJECTS+=;polly
endif

# Enable openmp (or not)
OPENMP_ENABLE=yes
ifneq (,$(filter $(DEB_HOST_ARCH), m68k mips mipsel powerpc powerpcspe riscv64 sparc64 s390x x32))
  OPENMP_ENABLE=no
else
  PROJECTS+=;openmp
#  CMAKE_EXTRA += -DLIBOMPTARGET_BUILD_NVPTX_BCLIB=ON -DLLVM_ENABLE_RUNTIMES=openmp
endif

# Enable libunwind (or not)
LIBUNWIND_ENABLE=yes
ifneq (,$(filter $(DEB_HOST_ARCH), s390x armel mipsel hurd-i386 powerpc))
  LIBUNWIND_ENABLE=no
else
  PROJECTS+=;libunwind
  CMAKE_LIBCXX_EXTRA += -DLIBCXXABI_USE_LLVM_UNWINDER=YES
endif

RUN_TEST=yes
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	RUN_TEST=no
endif
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)

## llvm-toolchain-13 13.0.0~+rc2

=== debian/changelog ===
llvm-toolchain-13 (1:13.0.0~+rc2-1) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Disable libunwind on m68k, sparc64 and x32

  [ Gianfranco Costamagna ]
  * integration-test-suite-test: fix build by using 13 as default version

  [ Sylvestre Ledru ]
  * New testing release

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 27 Aug 2021 09:43:28 +0200

llvm-toolchain-12 (1:12.0.1-7) UNRELEASED; urgency=medium

  * Add a patch to fix omp build on riscv64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Aug 2021 10:43:26 +0200

llvm-toolchain-12 (1:12.0.1-6) unstable; urgency=medium

  * Fixup build process on riscv64, the architecture building was enabled
    in control file but not in rules file, neither required build-deps were
    installed. (note: this should fail, but at least we will have a build log
    stored.
  * Add ocaml support on riscv64.
  * Don't require hello package on i386 (helps Ubuntu alternate dependencies)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 26 Aug 2021 15:33:24 +0200

=== debian/control ===
--- 
+++ 
@@ -15,11 +15,14 @@
     g++-multilib [amd64 i386 kfreebsd-amd64 mips mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
     libjs-mathjax, python3-recommonmark,
     doxygen, gfortran,
-    ocaml-nox [amd64 arm64 armhf ppc64el s390x],
-    ocaml-findlib [amd64 arm64 armhf ppc64el s390x],
-    libctypes-ocaml-dev [amd64 arm64 armhf ppc64el s390x],
-    dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el s390x],
-    libpfm4-dev [linux-any], python3-setuptools, libz3-dev
+    ocaml-nox [amd64 arm64 armhf ppc64el riscv64 s390x],
+    ocaml-findlib [amd64 arm64 armhf ppc64el riscv64 s390x],
+    libctypes-ocaml-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
+    dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el riscv64 s390x],
+    libpfm4-dev [linux-any], python3-setuptools, libz3-dev,
+    llvm-spirv [ amd64 arm64 armel armhf mips64el mipsel ppc64el s390x ] <!stage1> | hello [!i386],
+    spirv-tools [ linux-any ] | hello [ !i386]
+# "| hello" is for older buster/bionic distros without spirv support
 Build-Conflicts: oprofile, ocaml
 Standards-Version: 4.2.1
 Homepage: https://www.llvm.org/
@@ -288,11 +291,3 @@
 Breaks: llvm-13-dev (<< 1:13~++20210129063721), clang-13 (<< 1:13~++20210129063721)
 Replaces: llvm-13-dev (<< 1:13~++20210129063721), clang-13 (<< 1:13~++20210129063721)
 Description: Modular compiler and toolchain technologies - Plugins
- LLVM is a collection of libraries and tools that make it easy to build
- compilers, optimizers, just-in-time code generators, and many other
- compiler-related programs.
- .
- This package contains the LLVMgold and LLVMPolly linker plugins.
-
-Package: llvm-13
-Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -140,6 +140,17 @@
 	control_vars = '-Vdep:devlibs=libstdc++6-$(GCC_VERSION)-dev'
 endif
 
+ifeq ($(shell which llvm-spirv),)
+LLVM_SPIRV_INSTALLED = no
+else
+LLVM_SPIRV_INSTALLED = yes
+endif
+
+LIBCLC_TARGETS_TO_BUILD="amdgcn--;amdgcn--amdhsa;r600--;nvptx--;nvptx64--;nvptx--nvidiacl;nvptx64--nvidiacl"
+ifeq ($(LLVM_SPIRV_INSTALLED),yes)
+	LIBCLC_TARGETS_TO_BUILD := $(LIBCLC_TARGETS_TO_BUILD)";spirv-mesa3d-;spirv64-mesa3d-"
+endif
+
 # Disabled:
 #  Host compiler does not support '-fuse-ld=lld'
 # USE_LLD_ARCHS := amd64
@@ -189,7 +200,7 @@
 
 # Enable openmp (or not)
 OPENMP_ENABLE=yes
-ifneq (,$(filter $(DEB_HOST_ARCH), m68k mips mipsel powerpc powerpcspe riscv64 sparc64 s390x x32))
+ifneq (,$(filter $(DEB_HOST_ARCH), m68k mips mipsel powerpc powerpcspe sparc64 s390x x32))
   OPENMP_ENABLE=no
 else
   PROJECTS+=;openmp
@@ -198,15 +209,3 @@
 
 # Enable libunwind (or not)
 LIBUNWIND_ENABLE=yes
-ifneq (,$(filter $(DEB_HOST_ARCH), s390x armel mipsel hurd-i386 powerpc))
-  LIBUNWIND_ENABLE=no
-else
-  PROJECTS+=;libunwind
-  CMAKE_LIBCXX_EXTRA += -DLIBCXXABI_USE_LLVM_UNWINDER=YES
-endif
-
-RUN_TEST=yes
-ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	RUN_TEST=no
-endif
-ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)

## llvm-toolchain-13 13.0.0~+rc3

=== clang/tools/clang-repl/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 set( LLVM_LINK_COMPONENTS
   ${LLVM_TARGETS_TO_BUILD}
   Core
+  LineEditor
   Option
   OrcJIT
   Support
@@ -14,5 +15,4 @@
   clangBasic
   clangInterpreter
   clangTooling
-  LLVMLineEditor
   )

=== debian/changelog ===
llvm-toolchain-13 (1:13.0.0~+rc3-1ubuntu2) impish; urgency=medium

  * Build using GCC 10 on armhf. No idea about the build failure with GCC 11
    yet.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Sep 2021 19:41:26 +0200

llvm-toolchain-13 (1:13.0.0~+rc3-1) unstable; urgency=medium

  * New testing release
  * Remove debian/patches/disable-no-omit-leaf.diff
    as it is fixed upstream

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 11 Sep 2021 09:48:23 +0200

llvm-toolchain-13 (1:13.0.0~+rc2-3) unstable; urgency=medium

  * compiler-rt scudo, don't add the option
    -mno-omit-leaf-frame-pointer when building on
    armel & armhf

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 02 Sep 2021 21:35:26 +0200

llvm-toolchain-13 (1:13.0.0~+rc2-2) unstable; urgency=medium

  * Build with -DCMAKE_POSITION_INDEPENDENT_CODE=ON to libc++ and libc++abi
  * The changes from 12.0.1-7

  [ John Paul Adrian Glaubitz ]
  * Disable libunwind-X.Y{-dev} packages on sparc and sparc64

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 29 Aug 2021 14:52:16 +0200

llvm-toolchain-12 (1:12.0.1-8) unstable; urgency=medium

  * Add back CMAKE_EXTRA to build LLVM gold (Closes: #993664)

  [  Gianfranco Costamagna ]
  * Refresh symbols on riscv64

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 04 Sep 2021 16:38:24 +0200

llvm-toolchain-12 (1:12.0.1-7) unstable; urgency=medium

  * Add debian/source/options to ignore the diff (much much faster to repack)
  * cmake: use ON instead of YES for consistency
  * Don't generate the llvm-mcmarkup & lldb-mi manpages (don't exist anymore)
    (LP: #1940713)

  [  Gianfranco Costamagna ]
  * Add a patch to fix omp build on riscv64
  * Don't build lldb on riscv64, fails to build due to missing
    CreateHostNativeRegisterContextLinux implementation on this architecture.

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 31 Aug 2021 20:56:40 +0200

llvm-toolchain-11 (1:11.1.0-1~exp3) UNRELEASED; urgency=medium

  * Cherry-pick upstream commit to fix a libgl1-mesa-dri texture failure.
    (Closes: #989545)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 01 Sep 2021 12:24:34 +0200

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
     libjsoncpp-dev, pkg-config,
     lcov, procps, help2man, zlib1g-dev,
     g++-multilib [amd64 i386 kfreebsd-amd64 mips mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
+    g++-10 [armhf],
     libjs-mathjax, python3-recommonmark,
     doxygen, gfortran,
     ocaml-nox [amd64 arm64 armhf ppc64el riscv64 s390x],

=== debian/rules ===
--- 
+++ 
@@ -7,12 +7,12 @@
 TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
 DEB_INST		:= $(CURDIR)/debian/tmp/
 
-# Disable to move the previous method
-BUILD_METHOD := stage2
-
 GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
 GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
 GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))
+ifneq (,$(filter $(DEB_HOST_ARCH),armhf))
+  GCC_VERSION              := 10
+endif
 
 LLVM_VERSION   := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9]+).*,\1,p")
 LLVM_VERSION_FULL := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\1,p")
@@ -107,7 +107,7 @@
   # See http://lists.llvm.org/pipermail/llvm-dev/2016-May/099761.html
   CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
   # Check for ancient libstdc++ fails due to atomics usage
-  CMAKE_EXTRA_LIBCXX += -DLLVM_COMPILER_CHECKED=ON
+  CMAKE_LIBCXX_EXTRA += -DLLVM_COMPILER_CHECKED=ON
   # Prevent clang from getting a > v4t default
   # See bug #868779
   CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabi
@@ -204,7 +204,6 @@
   OPENMP_ENABLE=no
 else
   PROJECTS+=;openmp
-#  CMAKE_EXTRA += -DLIBOMPTARGET_BUILD_NVPTX_BCLIB=ON -DLLVM_ENABLE_RUNTIMES=openmp
 endif
 
 # Enable libunwind (or not)
